#ifdef GL_ES
precision lowp float;
#endif

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;

uniform vec2 resolution;
uniform float blurRadius;

void main(void)
{
    vec4 texColor = texture2D(CC_Texture0, v_texCoord);
    
    if(texColor.a > 0.5)
    {
        vec2 unit = 1.0 / resolution.xy;
        float r = blurRadius*0.15;
        float sampleStep = r *0.5;
        
        for(float x = -r; x <= r; x += sampleStep)
        {
            for(float y = -r; y <= r; y += sampleStep)
            {
                if(texture2D(CC_Texture0, v_texCoord + vec2(x * unit.x, y * unit.y)).a == 0.0)
                {
                    gl_FragColor = (texColor*texColor.a + vec4(0,0,0,0.125*0.125))/(0.125+texColor.a);
                    gl_FragColor.a = 1.0;
                    return;
                }
            }
        }
    }
    
    gl_FragColor = texColor;
}
