#ifdef GL_ES
precision lowp float;
#endif

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;

uniform vec2 resolution;
uniform float radius;

void main(void)
{
    vec4 texColor = texture2D(CC_Texture0, v_texCoord);
    
    if(texColor.a>0.5)
    {
        vec2 unit = 1.0 / resolution.xy;
        
        float i;

        float xDist=-1.0;
        float yDist=-1.0;
        
        for(i=0.0;i<radius;i+=1.0)
        {
            if(texture2D(CC_Texture0, v_texCoord + vec2(i*unit.x,0)).a == 0.0 ||
               texture2D(CC_Texture0, v_texCoord + vec2(-i*unit.x,0)).a == 0.0)
            {
                xDist=i;
                break;
            }
        }
        
        for(i=0.0;i<radius;i+=1.0)
        {
            if(texture2D(CC_Texture0, v_texCoord + vec2(0,i*unit.y)).a == 0.0 ||
               texture2D(CC_Texture0, v_texCoord + vec2(0,-i*unit.y)).a == 0.0)
            {
                yDist=i;
                break;
            }
        }
        
        if(xDist>-1.0 && yDist>-1.0 &&
           (radius-xDist)*(radius-xDist)+(radius-yDist)*(radius-yDist)>radius*radius)
        {
            gl_FragColor=vec4(0.0,0.0,0.0,0.0);
            return;
        }
    }
    
    gl_FragColor = texColor;
    
}

