#ifdef GL_ES
precision lowp float;
#endif

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;

uniform vec2 resolution;
uniform float blurRadius;

uniform float shadowDirectionFactorX;
uniform float shadowDirectionFactorY;
uniform int rInt;
uniform float r;
uniform int shadowSize;

void main(void)
{
    vec4 texColor = texture2D(CC_Texture0, v_texCoord);
   
    gl_FragColor = texColor;
    
    if(texColor.a < 0.5)
    {
        vec2 unit = 1.0 / resolution.xy;
        
        float col = 0.0;
        float count = 0.0;
        float weight;
        int x,y;
        
        for(x = rInt; x >= -rInt; x--)
        {
            for(y = rInt; y >= -rInt; y--)
            {
                weight = 0.0175 * (3.0 * r - abs(3.0 * float(x))) * (3.0 * r - abs(3.0 * float(y)));
                col += texture2D(CC_Texture0, v_texCoord + vec2(3.0 * float(x) * unit.x, 3.0 * float(y) * unit.y)).a * 0.625 * weight;
                count += weight;
            }
        }
        
        gl_FragColor.a = col / count;
        
        for(x=0;x<shadowSize;x++)
        {
            if(texture2D(CC_Texture0,  v_texCoord + vec2(float(x) * unit.x * shadowDirectionFactorX, float(x) * unit.y * shadowDirectionFactorY)).a == 1.0)
            {
                gl_FragColor.a = gl_FragColor.a + 0.1 + (float(shadowSize-x)/float(shadowSize))*0.15;
                
                return;
            }
        }
    }
    
}
